#if os(macOS)
import SystemConfiguration
#endif
// This file was autogenerated by some hot garbage in the `uniffi` crate.
// Trust me, you don't want to mess with it!

// swiftlint:disable all
import Foundation

// Depending on the consumer's build setup, the low-level FFI code
// might be in a separate module, or it might be compiled inline into
// this module. This is a bit of light hackery to work with both.
#if canImport(CooklangParserFFI)
    import CooklangParserFFI
#endif

private extension RustBuffer {
    // Allocate a new buffer, copying the contents of a `UInt8` array.
    init(bytes: [UInt8]) {
        let rbuf = bytes.withUnsafeBufferPointer { ptr in
            RustBuffer.from(ptr)
        }
        self.init(capacity: rbuf.capacity, len: rbuf.len, data: rbuf.data)
    }

    static func empty() -> RustBuffer {
        RustBuffer(capacity: 0, len: 0, data: nil)
    }

    static func from(_ ptr: UnsafeBufferPointer<UInt8>) -> RustBuffer {
        try! rustCall { ffi_cooklang_bindings_rustbuffer_from_bytes(ForeignBytes(bufferPointer: ptr), $0) }
    }

    // Frees the buffer in place.
    // The buffer must not be used after this is called.
    func deallocate() {
        try! rustCall { ffi_cooklang_bindings_rustbuffer_free(self, $0) }
    }
}

private extension ForeignBytes {
    init(bufferPointer: UnsafeBufferPointer<UInt8>) {
        self.init(len: Int32(bufferPointer.count), data: bufferPointer.baseAddress)
    }
}

// For every type used in the interface, we provide helper methods for conveniently
// lifting and lowering that type from C-compatible data, and for reading and writing
// values of that type in a buffer.

// Helper classes/extensions that don't change.
// Someday, this will be in a library of its own.

private extension Data {
    init(rustBuffer: RustBuffer) {
        self.init(
            bytesNoCopy: rustBuffer.data!,
            count: Int(rustBuffer.len),
            deallocator: .none
        )
    }
}

// Define reader functionality.  Normally this would be defined in a class or
// struct, but we use standalone functions instead in order to make external
// types work.
//
// With external types, one swift source file needs to be able to call the read
// method on another source file's FfiConverter, but then what visibility
// should Reader have?
// - If Reader is fileprivate, then this means the read() must also
//   be fileprivate, which doesn't work with external types.
// - If Reader is internal/public, we'll get compile errors since both source
//   files will try define the same type.
//
// Instead, the read() method and these helper functions input a tuple of data

private func createReader(data: Data) -> (data: Data, offset: Data.Index) {
    (data: data, offset: 0)
}

// Reads an integer at the current offset, in big-endian order, and advances
// the offset on success. Throws if reading the integer would move the
// offset past the end of the buffer.
private func readInt<T: FixedWidthInteger>(_ reader: inout (data: Data, offset: Data.Index)) throws -> T {
    let range = reader.offset ..< reader.offset + MemoryLayout<T>.size
    guard reader.data.count >= range.upperBound else {
        throw UniffiInternalError.bufferOverflow
    }
    if T.self == UInt8.self {
        let value = reader.data[reader.offset]
        reader.offset += 1
        return value as! T
    }
    var value: T = 0
    let _ = withUnsafeMutableBytes(of: &value) { reader.data.copyBytes(to: $0, from: range) }
    reader.offset = range.upperBound
    return value.bigEndian
}

// Reads an arbitrary number of bytes, to be used to read
// raw bytes, this is useful when lifting strings
private func readBytes(_ reader: inout (data: Data, offset: Data.Index), count: Int) throws -> [UInt8] {
    let range = reader.offset ..< (reader.offset + count)
    guard reader.data.count >= range.upperBound else {
        throw UniffiInternalError.bufferOverflow
    }
    var value = [UInt8](repeating: 0, count: count)
    value.withUnsafeMutableBufferPointer { buffer in
        reader.data.copyBytes(to: buffer, from: range)
    }
    reader.offset = range.upperBound
    return value
}

// Reads a float at the current offset.
private func readFloat(_ reader: inout (data: Data, offset: Data.Index)) throws -> Float {
    return try Float(bitPattern: readInt(&reader))
}

// Reads a float at the current offset.
private func readDouble(_ reader: inout (data: Data, offset: Data.Index)) throws -> Double {
    return try Double(bitPattern: readInt(&reader))
}

// Indicates if the offset has reached the end of the buffer.
private func hasRemaining(_ reader: (data: Data, offset: Data.Index)) -> Bool {
    return reader.offset < reader.data.count
}

// Define writer functionality.  Normally this would be defined in a class or
// struct, but we use standalone functions instead in order to make external
// types work.  See the above discussion on Readers for details.

private func createWriter() -> [UInt8] {
    return []
}

private func writeBytes<S>(_ writer: inout [UInt8], _ byteArr: S) where S: Sequence, S.Element == UInt8 {
    writer.append(contentsOf: byteArr)
}

// Writes an integer in big-endian order.
//
// Warning: make sure what you are trying to write
// is in the correct type!
private func writeInt<T: FixedWidthInteger>(_ writer: inout [UInt8], _ value: T) {
    var value = value.bigEndian
    withUnsafeBytes(of: &value) { writer.append(contentsOf: $0) }
}

private func writeFloat(_ writer: inout [UInt8], _ value: Float) {
    writeInt(&writer, value.bitPattern)
}

private func writeDouble(_ writer: inout [UInt8], _ value: Double) {
    writeInt(&writer, value.bitPattern)
}

// Protocol for types that transfer other types across the FFI. This is
// analogous to the Rust trait of the same name.
private protocol FfiConverter {
    associatedtype FfiType
    associatedtype SwiftType

    static func lift(_ value: FfiType) throws -> SwiftType
    static func lower(_ value: SwiftType) -> FfiType
    static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> SwiftType
    static func write(_ value: SwiftType, into buf: inout [UInt8])
}

// Types conforming to `Primitive` pass themselves directly over the FFI.
private protocol FfiConverterPrimitive: FfiConverter where FfiType == SwiftType {}

extension FfiConverterPrimitive {
    public static func lift(_ value: FfiType) throws -> SwiftType {
        return value
    }

    public static func lower(_ value: SwiftType) -> FfiType {
        return value
    }
}

// Types conforming to `FfiConverterRustBuffer` lift and lower into a `RustBuffer`.
// Used for complex types where it's hard to write a custom lift/lower.
private protocol FfiConverterRustBuffer: FfiConverter where FfiType == RustBuffer {}

extension FfiConverterRustBuffer {
    public static func lift(_ buf: RustBuffer) throws -> SwiftType {
        var reader = createReader(data: Data(rustBuffer: buf))
        let value = try read(from: &reader)
        if hasRemaining(reader) {
            throw UniffiInternalError.incompleteData
        }
        buf.deallocate()
        return value
    }

    public static func lower(_ value: SwiftType) -> RustBuffer {
        var writer = createWriter()
        write(value, into: &writer)
        return RustBuffer(bytes: writer)
    }
}

// An error type for FFI errors. These errors occur at the UniFFI level, not
// the library level.
private enum UniffiInternalError: LocalizedError {
    case bufferOverflow
    case incompleteData
    case unexpectedOptionalTag
    case unexpectedEnumCase
    case unexpectedNullPointer
    case unexpectedRustCallStatusCode
    case unexpectedRustCallError
    case unexpectedStaleHandle
    case rustPanic(_ message: String)

    public var errorDescription: String? {
        switch self {
        case .bufferOverflow: return "Reading the requested value would read past the end of the buffer"
        case .incompleteData: return "The buffer still has data after lifting its containing value"
        case .unexpectedOptionalTag: return "Unexpected optional tag; should be 0 or 1"
        case .unexpectedEnumCase: return "Raw enum value doesn't match any cases"
        case .unexpectedNullPointer: return "Raw pointer value was null"
        case .unexpectedRustCallStatusCode: return "Unexpected RustCallStatus code"
        case .unexpectedRustCallError: return "CALL_ERROR but no errorClass specified"
        case .unexpectedStaleHandle: return "The object in the handle map has been dropped already"
        case let .rustPanic(message): return message
        }
    }
}

private extension NSLock {
    func withLock<T>(f: () throws -> T) rethrows -> T {
        lock()
        defer { self.unlock() }
        return try f()
    }
}

private let CALL_SUCCESS: Int8 = 0
private let CALL_ERROR: Int8 = 1
private let CALL_UNEXPECTED_ERROR: Int8 = 2
private let CALL_CANCELLED: Int8 = 3

private extension RustCallStatus {
    init() {
        self.init(
            code: CALL_SUCCESS,
            errorBuf: RustBuffer(
                capacity: 0,
                len: 0,
                data: nil
            )
        )
    }
}

private func rustCall<T>(_ callback: (UnsafeMutablePointer<RustCallStatus>) -> T) throws -> T {
    let neverThrow: ((RustBuffer) throws -> Never)? = nil
    return try makeRustCall(callback, errorHandler: neverThrow)
}

private func rustCallWithError<T, E: Swift.Error>(
    _ errorHandler: @escaping (RustBuffer) throws -> E,
    _ callback: (UnsafeMutablePointer<RustCallStatus>) -> T
) throws -> T {
    try makeRustCall(callback, errorHandler: errorHandler)
}

private func makeRustCall<T, E: Swift.Error>(
    _ callback: (UnsafeMutablePointer<RustCallStatus>) -> T,
    errorHandler: ((RustBuffer) throws -> E)?
) throws -> T {
    uniffiEnsureInitialized()
    var callStatus = RustCallStatus()
    let returnedVal = callback(&callStatus)
    try uniffiCheckCallStatus(callStatus: callStatus, errorHandler: errorHandler)
    return returnedVal
}

private func uniffiCheckCallStatus<E: Swift.Error>(
    callStatus: RustCallStatus,
    errorHandler: ((RustBuffer) throws -> E)?
) throws {
    switch callStatus.code {
    case CALL_SUCCESS:
        return

    case CALL_ERROR:
        if let errorHandler = errorHandler {
            throw try errorHandler(callStatus.errorBuf)
        } else {
            callStatus.errorBuf.deallocate()
            throw UniffiInternalError.unexpectedRustCallError
        }

    case CALL_UNEXPECTED_ERROR:
        // When the rust code sees a panic, it tries to construct a RustBuffer
        // with the message.  But if that code panics, then it just sends back
        // an empty buffer.
        if callStatus.errorBuf.len > 0 {
            throw try UniffiInternalError.rustPanic(FfiConverterString.lift(callStatus.errorBuf))
        } else {
            callStatus.errorBuf.deallocate()
            throw UniffiInternalError.rustPanic("Rust panic")
        }

    case CALL_CANCELLED:
        fatalError("Cancellation not supported yet")

    default:
        throw UniffiInternalError.unexpectedRustCallStatusCode
    }
}

private func uniffiTraitInterfaceCall<T>(
    callStatus: UnsafeMutablePointer<RustCallStatus>,
    makeCall: () throws -> T,
    writeReturn: (T) -> Void
) {
    do {
        try writeReturn(makeCall())
    } catch {
        callStatus.pointee.code = CALL_UNEXPECTED_ERROR
        callStatus.pointee.errorBuf = FfiConverterString.lower(String(describing: error))
    }
}

private func uniffiTraitInterfaceCallWithError<T, E>(
    callStatus: UnsafeMutablePointer<RustCallStatus>,
    makeCall: () throws -> T,
    writeReturn: (T) -> Void,
    lowerError: (E) -> RustBuffer
) {
    do {
        try writeReturn(makeCall())
    } catch let error as E {
        callStatus.pointee.code = CALL_ERROR
        callStatus.pointee.errorBuf = lowerError(error)
    } catch {
        callStatus.pointee.code = CALL_UNEXPECTED_ERROR
        callStatus.pointee.errorBuf = FfiConverterString.lower(String(describing: error))
    }
}

private class UniffiHandleMap<T> {
    private var map: [UInt64: T] = [:]
    private let lock = NSLock()
    private var currentHandle: UInt64 = 1

    func insert(obj: T) -> UInt64 {
        lock.withLock {
            let handle = currentHandle
            currentHandle += 1
            map[handle] = obj
            return handle
        }
    }

    func get(handle: UInt64) throws -> T {
        try lock.withLock {
            guard let obj = map[handle] else {
                throw UniffiInternalError.unexpectedStaleHandle
            }
            return obj
        }
    }

    @discardableResult
    func remove(handle: UInt64) throws -> T {
        try lock.withLock {
            guard let obj = map.removeValue(forKey: handle) else {
                throw UniffiInternalError.unexpectedStaleHandle
            }
            return obj
        }
    }

    var count: Int {
        map.count
    }
}

// Public interface members begin here.

private struct FfiConverterDouble: FfiConverterPrimitive {
    typealias FfiType = Double
    typealias SwiftType = Double

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> Double {
        return try lift(readDouble(&buf))
    }

    public static func write(_ value: Double, into buf: inout [UInt8]) {
        writeDouble(&buf, lower(value))
    }
}

private struct FfiConverterString: FfiConverter {
    typealias SwiftType = String
    typealias FfiType = RustBuffer

    public static func lift(_ value: RustBuffer) throws -> String {
        defer {
            value.deallocate()
        }
        if value.data == nil {
            return String()
        }
        let bytes = UnsafeBufferPointer<UInt8>(start: value.data!, count: Int(value.len))
        return String(bytes: bytes, encoding: String.Encoding.utf8)!
    }

    public static func lower(_ value: String) -> RustBuffer {
        return value.utf8CString.withUnsafeBufferPointer { ptr in
            // The swift string gives us int8_t, we want uint8_t.
            ptr.withMemoryRebound(to: UInt8.self) { ptr in
                // The swift string gives us a trailing null byte, we don't want it.
                let buf = UnsafeBufferPointer(rebasing: ptr.prefix(upTo: ptr.count - 1))
                return RustBuffer.from(buf)
            }
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> String {
        let len: Int32 = try readInt(&buf)
        return try String(bytes: readBytes(&buf, count: Int(len)), encoding: String.Encoding.utf8)!
    }

    public static func write(_ value: String, into buf: inout [UInt8]) {
        let len = Int32(value.utf8.count)
        writeInt(&buf, len)
        writeBytes(&buf, value.utf8)
    }
}

public protocol AisleConfProtocol: AnyObject {
    func categoryFor(ingredientName: String) -> String?
}

open class AisleConf:
    AisleConfProtocol
{
    fileprivate let pointer: UnsafeMutableRawPointer!

    /// Used to instantiate a [FFIObject] without an actual pointer, for fakes in tests, mostly.
    public struct NoPointer {
        public init() {}
    }

    // TODO: We'd like this to be `private` but for Swifty reasons,
    // we can't implement `FfiConverter` without making this `required` and we can't
    // make it `required` without making it `public`.
    public required init(unsafeFromRawPointer pointer: UnsafeMutableRawPointer) {
        self.pointer = pointer
    }

    /// This constructor can be used to instantiate a fake object.
    /// - Parameter noPointer: Placeholder value so we can have a constructor separate from the default empty one that may be implemented for classes extending [FFIObject].
    ///
    /// - Warning:
    ///     Any object instantiated with this constructor cannot be passed to an actual Rust-backed object. Since there isn't a backing [Pointer] the FFI lower functions will crash.
    public init(noPointer _: NoPointer) {
        pointer = nil
    }

    public func uniffiClonePointer() -> UnsafeMutableRawPointer {
        return try! rustCall { uniffi_cooklang_bindings_fn_clone_aisleconf(self.pointer, $0) }
    }

    // No primary constructor declared for this class.

    deinit {
        guard let pointer = pointer else {
            return
        }

        try! rustCall { uniffi_cooklang_bindings_fn_free_aisleconf(pointer, $0) }
    }

    open func categoryFor(ingredientName: String) -> String? {
        return try! FfiConverterOptionString.lift(try! rustCall {
            uniffi_cooklang_bindings_fn_method_aisleconf_category_for(self.uniffiClonePointer(),
                                                                      FfiConverterString.lower(ingredientName), $0)
        })
    }
}

public struct FfiConverterTypeAisleConf: FfiConverter {
    typealias FfiType = UnsafeMutableRawPointer
    typealias SwiftType = AisleConf

    public static func lift(_ pointer: UnsafeMutableRawPointer) throws -> AisleConf {
        return AisleConf(unsafeFromRawPointer: pointer)
    }

    public static func lower(_ value: AisleConf) -> UnsafeMutableRawPointer {
        return value.uniffiClonePointer()
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> AisleConf {
        let v: UInt64 = try readInt(&buf)
        // The Rust code won't compile if a pointer won't fit in a UInt64.
        // We have to go via `UInt` because that's the thing that's the size of a pointer.
        let ptr = UnsafeMutableRawPointer(bitPattern: UInt(truncatingIfNeeded: v))
        if ptr == nil {
            throw UniffiInternalError.unexpectedNullPointer
        }
        return try lift(ptr!)
    }

    public static func write(_ value: AisleConf, into buf: inout [UInt8]) {
        // This fiddling is because `Int` is the thing that's the same size as a pointer.
        // The Rust code won't compile if a pointer won't fit in a `UInt64`.
        writeInt(&buf, UInt64(bitPattern: Int64(Int(bitPattern: lower(value)))))
    }
}

public func FfiConverterTypeAisleConf_lift(_ pointer: UnsafeMutableRawPointer) throws -> AisleConf {
    return try FfiConverterTypeAisleConf.lift(pointer)
}

public func FfiConverterTypeAisleConf_lower(_ value: AisleConf) -> UnsafeMutableRawPointer {
    return FfiConverterTypeAisleConf.lower(value)
}

public struct AisleCategory {
    public let name: String
    public let ingredients: [AisleIngredient]

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(name: String, ingredients: [AisleIngredient]) {
        self.name = name
        self.ingredients = ingredients
    }
}

extension AisleCategory: Equatable, Hashable {
    public static func == (lhs: AisleCategory, rhs: AisleCategory) -> Bool {
        if lhs.name != rhs.name {
            return false
        }
        if lhs.ingredients != rhs.ingredients {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(name)
        hasher.combine(ingredients)
    }
}

public struct FfiConverterTypeAisleCategory: FfiConverterRustBuffer {
    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> AisleCategory {
        return
            try AisleCategory(
                name: FfiConverterString.read(from: &buf),
                ingredients: FfiConverterSequenceTypeAisleIngredient.read(from: &buf)
            )
    }

    public static func write(_ value: AisleCategory, into buf: inout [UInt8]) {
        FfiConverterString.write(value.name, into: &buf)
        FfiConverterSequenceTypeAisleIngredient.write(value.ingredients, into: &buf)
    }
}

public func FfiConverterTypeAisleCategory_lift(_ buf: RustBuffer) throws -> AisleCategory {
    return try FfiConverterTypeAisleCategory.lift(buf)
}

public func FfiConverterTypeAisleCategory_lower(_ value: AisleCategory) -> RustBuffer {
    return FfiConverterTypeAisleCategory.lower(value)
}

public struct AisleIngredient {
    public let name: String
    public let aliases: [String]

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(name: String, aliases: [String]) {
        self.name = name
        self.aliases = aliases
    }
}

extension AisleIngredient: Equatable, Hashable {
    public static func == (lhs: AisleIngredient, rhs: AisleIngredient) -> Bool {
        if lhs.name != rhs.name {
            return false
        }
        if lhs.aliases != rhs.aliases {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(name)
        hasher.combine(aliases)
    }
}

public struct FfiConverterTypeAisleIngredient: FfiConverterRustBuffer {
    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> AisleIngredient {
        return
            try AisleIngredient(
                name: FfiConverterString.read(from: &buf),
                aliases: FfiConverterSequenceString.read(from: &buf)
            )
    }

    public static func write(_ value: AisleIngredient, into buf: inout [UInt8]) {
        FfiConverterString.write(value.name, into: &buf)
        FfiConverterSequenceString.write(value.aliases, into: &buf)
    }
}

public func FfiConverterTypeAisleIngredient_lift(_ buf: RustBuffer) throws -> AisleIngredient {
    return try FfiConverterTypeAisleIngredient.lift(buf)
}

public func FfiConverterTypeAisleIngredient_lower(_ value: AisleIngredient) -> RustBuffer {
    return FfiConverterTypeAisleIngredient.lower(value)
}

public struct Amount {
    public let quantity: Value
    public let units: String?

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(quantity: Value, units: String?) {
        self.quantity = quantity
        self.units = units
    }
}

extension Amount: Equatable, Hashable {
    public static func == (lhs: Amount, rhs: Amount) -> Bool {
        if lhs.quantity != rhs.quantity {
            return false
        }
        if lhs.units != rhs.units {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(quantity)
        hasher.combine(units)
    }
}

public struct FfiConverterTypeAmount: FfiConverterRustBuffer {
    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> Amount {
        return
            try Amount(
                quantity: FfiConverterTypeValue.read(from: &buf),
                units: FfiConverterOptionString.read(from: &buf)
            )
    }

    public static func write(_ value: Amount, into buf: inout [UInt8]) {
        FfiConverterTypeValue.write(value.quantity, into: &buf)
        FfiConverterOptionString.write(value.units, into: &buf)
    }
}

public func FfiConverterTypeAmount_lift(_ buf: RustBuffer) throws -> Amount {
    return try FfiConverterTypeAmount.lift(buf)
}

public func FfiConverterTypeAmount_lower(_ value: Amount) -> RustBuffer {
    return FfiConverterTypeAmount.lower(value)
}

public struct CooklangRecipe {
    public let metadata: [String: String]
    public let steps: [Step]
    public let ingredients: [String: [GroupedQuantityKey: Value]]
    public let cookware: [Item]

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(metadata: [String: String], steps: [Step], ingredients: [String: [GroupedQuantityKey: Value]], cookware: [Item]) {
        self.metadata = metadata
        self.steps = steps
        self.ingredients = ingredients
        self.cookware = cookware
    }
}

extension CooklangRecipe: Equatable, Hashable {
    public static func == (lhs: CooklangRecipe, rhs: CooklangRecipe) -> Bool {
        if lhs.metadata != rhs.metadata {
            return false
        }
        if lhs.steps != rhs.steps {
            return false
        }
        if lhs.ingredients != rhs.ingredients {
            return false
        }
        if lhs.cookware != rhs.cookware {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(metadata)
        hasher.combine(steps)
        hasher.combine(ingredients)
        hasher.combine(cookware)
    }
}

public struct FfiConverterTypeCooklangRecipe: FfiConverterRustBuffer {
    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> CooklangRecipe {
        return
            try CooklangRecipe(
                metadata: FfiConverterDictionaryStringString.read(from: &buf),
                steps: FfiConverterSequenceTypeStep.read(from: &buf),
                ingredients: FfiConverterDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue.read(from: &buf),
                cookware: FfiConverterSequenceTypeItem.read(from: &buf)
            )
    }

    public static func write(_ value: CooklangRecipe, into buf: inout [UInt8]) {
        FfiConverterDictionaryStringString.write(value.metadata, into: &buf)
        FfiConverterSequenceTypeStep.write(value.steps, into: &buf)
        FfiConverterDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue.write(value.ingredients, into: &buf)
        FfiConverterSequenceTypeItem.write(value.cookware, into: &buf)
    }
}

public func FfiConverterTypeCooklangRecipe_lift(_ buf: RustBuffer) throws -> CooklangRecipe {
    return try FfiConverterTypeCooklangRecipe.lift(buf)
}

public func FfiConverterTypeCooklangRecipe_lower(_ value: CooklangRecipe) -> RustBuffer {
    return FfiConverterTypeCooklangRecipe.lower(value)
}

public struct GroupedQuantityKey {
    public let name: String
    public let unitType: QuantityType

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(name: String, unitType: QuantityType) {
        self.name = name
        self.unitType = unitType
    }
}

extension GroupedQuantityKey: Equatable, Hashable {
    public static func == (lhs: GroupedQuantityKey, rhs: GroupedQuantityKey) -> Bool {
        if lhs.name != rhs.name {
            return false
        }
        if lhs.unitType != rhs.unitType {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(name)
        hasher.combine(unitType)
    }
}

public struct FfiConverterTypeGroupedQuantityKey: FfiConverterRustBuffer {
    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> GroupedQuantityKey {
        return
            try GroupedQuantityKey(
                name: FfiConverterString.read(from: &buf),
                unitType: FfiConverterTypeQuantityType.read(from: &buf)
            )
    }

    public static func write(_ value: GroupedQuantityKey, into buf: inout [UInt8]) {
        FfiConverterString.write(value.name, into: &buf)
        FfiConverterTypeQuantityType.write(value.unitType, into: &buf)
    }
}

public func FfiConverterTypeGroupedQuantityKey_lift(_ buf: RustBuffer) throws -> GroupedQuantityKey {
    return try FfiConverterTypeGroupedQuantityKey.lift(buf)
}

public func FfiConverterTypeGroupedQuantityKey_lower(_ value: GroupedQuantityKey) -> RustBuffer {
    return FfiConverterTypeGroupedQuantityKey.lower(value)
}

public struct Step {
    public let items: [Item]

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(items: [Item]) {
        self.items = items
    }
}

extension Step: Equatable, Hashable {
    public static func == (lhs: Step, rhs: Step) -> Bool {
        if lhs.items != rhs.items {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(items)
    }
}

public struct FfiConverterTypeStep: FfiConverterRustBuffer {
    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> Step {
        return
            try Step(
                items: FfiConverterSequenceTypeItem.read(from: &buf)
            )
    }

    public static func write(_ value: Step, into buf: inout [UInt8]) {
        FfiConverterSequenceTypeItem.write(value.items, into: &buf)
    }
}

public func FfiConverterTypeStep_lift(_ buf: RustBuffer) throws -> Step {
    return try FfiConverterTypeStep.lift(buf)
}

public func FfiConverterTypeStep_lower(_ value: Step) -> RustBuffer {
    return FfiConverterTypeStep.lower(value)
}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.

public enum Item {
    case text(value: String
    )
    case ingredient(name: String, amount: Amount?)
    case cookware(name: String, amount: Amount?)
    case timer(name: String?, amount: Amount?)
}

public struct FfiConverterTypeItem: FfiConverterRustBuffer {
    typealias SwiftType = Item

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> Item {
        let variant: Int32 = try readInt(&buf)
        switch variant {
        case 1: return try .text(value: FfiConverterString.read(from: &buf)
            )

        case 2: return try .ingredient(name: FfiConverterString.read(from: &buf), amount: FfiConverterOptionTypeAmount.read(from: &buf))

        case 3: return try .cookware(name: FfiConverterString.read(from: &buf), amount: FfiConverterOptionTypeAmount.read(from: &buf))

        case 4: return try .timer(name: FfiConverterOptionString.read(from: &buf), amount: FfiConverterOptionTypeAmount.read(from: &buf))

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    public static func write(_ value: Item, into buf: inout [UInt8]) {
        switch value {
        case let .text(value):
            writeInt(&buf, Int32(1))
            FfiConverterString.write(value, into: &buf)

        case let .ingredient(name, amount):
            writeInt(&buf, Int32(2))
            FfiConverterString.write(name, into: &buf)
            FfiConverterOptionTypeAmount.write(amount, into: &buf)

        case let .cookware(name, amount):
            writeInt(&buf, Int32(3))
            FfiConverterString.write(name, into: &buf)
            FfiConverterOptionTypeAmount.write(amount, into: &buf)

        case let .timer(name, amount):
            writeInt(&buf, Int32(4))
            FfiConverterOptionString.write(name, into: &buf)
            FfiConverterOptionTypeAmount.write(amount, into: &buf)
        }
    }
}

public func FfiConverterTypeItem_lift(_ buf: RustBuffer) throws -> Item {
    return try FfiConverterTypeItem.lift(buf)
}

public func FfiConverterTypeItem_lower(_ value: Item) -> RustBuffer {
    return FfiConverterTypeItem.lower(value)
}

extension Item: Equatable, Hashable {}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.

public enum QuantityType {
    case number
    case range
    case text
    case empty
}

public struct FfiConverterTypeQuantityType: FfiConverterRustBuffer {
    typealias SwiftType = QuantityType

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> QuantityType {
        let variant: Int32 = try readInt(&buf)
        switch variant {
        case 1: return .number

        case 2: return .range

        case 3: return .text

        case 4: return .empty

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    public static func write(_ value: QuantityType, into buf: inout [UInt8]) {
        switch value {
        case .number:
            writeInt(&buf, Int32(1))

        case .range:
            writeInt(&buf, Int32(2))

        case .text:
            writeInt(&buf, Int32(3))

        case .empty:
            writeInt(&buf, Int32(4))
        }
    }
}

public func FfiConverterTypeQuantityType_lift(_ buf: RustBuffer) throws -> QuantityType {
    return try FfiConverterTypeQuantityType.lift(buf)
}

public func FfiConverterTypeQuantityType_lower(_ value: QuantityType) -> RustBuffer {
    return FfiConverterTypeQuantityType.lower(value)
}

extension QuantityType: Equatable, Hashable {}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.

public enum Value {
    case number(value: Double
    )
    case range(start: Double, end: Double)
    case text(value: String
    )
    case empty
}

public struct FfiConverterTypeValue: FfiConverterRustBuffer {
    typealias SwiftType = Value

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> Value {
        let variant: Int32 = try readInt(&buf)
        switch variant {
        case 1: return try .number(value: FfiConverterDouble.read(from: &buf)
            )

        case 2: return try .range(start: FfiConverterDouble.read(from: &buf), end: FfiConverterDouble.read(from: &buf))

        case 3: return try .text(value: FfiConverterString.read(from: &buf)
            )

        case 4: return .empty

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    public static func write(_ value: Value, into buf: inout [UInt8]) {
        switch value {
        case let .number(value):
            writeInt(&buf, Int32(1))
            FfiConverterDouble.write(value, into: &buf)

        case let .range(start, end):
            writeInt(&buf, Int32(2))
            FfiConverterDouble.write(start, into: &buf)
            FfiConverterDouble.write(end, into: &buf)

        case let .text(value):
            writeInt(&buf, Int32(3))
            FfiConverterString.write(value, into: &buf)

        case .empty:
            writeInt(&buf, Int32(4))
        }
    }
}

public func FfiConverterTypeValue_lift(_ buf: RustBuffer) throws -> Value {
    return try FfiConverterTypeValue.lift(buf)
}

public func FfiConverterTypeValue_lower(_ value: Value) -> RustBuffer {
    return FfiConverterTypeValue.lower(value)
}

extension Value: Equatable, Hashable {}

private struct FfiConverterOptionString: FfiConverterRustBuffer {
    typealias SwiftType = String?

    public static func write(_ value: SwiftType, into buf: inout [UInt8]) {
        guard let value = value else {
            writeInt(&buf, Int8(0))
            return
        }
        writeInt(&buf, Int8(1))
        FfiConverterString.write(value, into: &buf)
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> SwiftType {
        switch try readInt(&buf) as Int8 {
        case 0: return nil
        case 1: return try FfiConverterString.read(from: &buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeAmount: FfiConverterRustBuffer {
    typealias SwiftType = Amount?

    public static func write(_ value: SwiftType, into buf: inout [UInt8]) {
        guard let value = value else {
            writeInt(&buf, Int8(0))
            return
        }
        writeInt(&buf, Int8(1))
        FfiConverterTypeAmount.write(value, into: &buf)
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> SwiftType {
        switch try readInt(&buf) as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeAmount.read(from: &buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterSequenceString: FfiConverterRustBuffer {
    typealias SwiftType = [String]

    public static func write(_ value: [String], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for item in value {
            FfiConverterString.write(item, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [String] {
        let len: Int32 = try readInt(&buf)
        var seq = [String]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            try seq.append(FfiConverterString.read(from: &buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeAisleIngredient: FfiConverterRustBuffer {
    typealias SwiftType = [AisleIngredient]

    public static func write(_ value: [AisleIngredient], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for item in value {
            FfiConverterTypeAisleIngredient.write(item, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [AisleIngredient] {
        let len: Int32 = try readInt(&buf)
        var seq = [AisleIngredient]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            try seq.append(FfiConverterTypeAisleIngredient.read(from: &buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeStep: FfiConverterRustBuffer {
    typealias SwiftType = [Step]

    public static func write(_ value: [Step], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for item in value {
            FfiConverterTypeStep.write(item, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [Step] {
        let len: Int32 = try readInt(&buf)
        var seq = [Step]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            try seq.append(FfiConverterTypeStep.read(from: &buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeItem: FfiConverterRustBuffer {
    typealias SwiftType = [Item]

    public static func write(_ value: [Item], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for item in value {
            FfiConverterTypeItem.write(item, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [Item] {
        let len: Int32 = try readInt(&buf)
        var seq = [Item]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            try seq.append(FfiConverterTypeItem.read(from: &buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue: FfiConverterRustBuffer {
    typealias SwiftType = [[String: [GroupedQuantityKey: Value]]]

    public static func write(_ value: [[String: [GroupedQuantityKey: Value]]], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for item in value {
            FfiConverterDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue.write(item, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [[String: [GroupedQuantityKey: Value]]] {
        let len: Int32 = try readInt(&buf)
        var seq = [[String: [GroupedQuantityKey: Value]]]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            try seq.append(FfiConverterDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue.read(from: &buf))
        }
        return seq
    }
}

private struct FfiConverterDictionaryStringString: FfiConverterRustBuffer {
    public static func write(_ value: [String: String], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for (key, value) in value {
            FfiConverterString.write(key, into: &buf)
            FfiConverterString.write(value, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [String: String] {
        let len: Int32 = try readInt(&buf)
        var dict = [String: String]()
        dict.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            let key = try FfiConverterString.read(from: &buf)
            let value = try FfiConverterString.read(from: &buf)
            dict[key] = value
        }
        return dict
    }
}

private struct FfiConverterDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue: FfiConverterRustBuffer {
    public static func write(_ value: [String: [GroupedQuantityKey: Value]], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for (key, value) in value {
            FfiConverterString.write(key, into: &buf)
            FfiConverterDictionaryTypeGroupedQuantityKeyTypeValue.write(value, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [String: [GroupedQuantityKey: Value]] {
        let len: Int32 = try readInt(&buf)
        var dict = [String: [GroupedQuantityKey: Value]]()
        dict.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            let key = try FfiConverterString.read(from: &buf)
            let value = try FfiConverterDictionaryTypeGroupedQuantityKeyTypeValue.read(from: &buf)
            dict[key] = value
        }
        return dict
    }
}

private struct FfiConverterDictionaryTypeGroupedQuantityKeyTypeValue: FfiConverterRustBuffer {
    public static func write(_ value: [GroupedQuantityKey: Value], into buf: inout [UInt8]) {
        let len = Int32(value.count)
        writeInt(&buf, len)
        for (key, value) in value {
            FfiConverterTypeGroupedQuantityKey.write(key, into: &buf)
            FfiConverterTypeValue.write(value, into: &buf)
        }
    }

    public static func read(from buf: inout (data: Data, offset: Data.Index)) throws -> [GroupedQuantityKey: Value] {
        let len: Int32 = try readInt(&buf)
        var dict = [GroupedQuantityKey: Value]()
        dict.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            let key = try FfiConverterTypeGroupedQuantityKey.read(from: &buf)
            let value = try FfiConverterTypeValue.read(from: &buf)
            dict[key] = value
        }
        return dict
    }
}

public func combineIngredientLists(lists: [[String: [GroupedQuantityKey: Value]]]) -> [String: [GroupedQuantityKey: Value]] {
    return try! FfiConverterDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue.lift(try! rustCall {
        uniffi_cooklang_bindings_fn_func_combine_ingredient_lists(
            FfiConverterSequenceDictionaryStringDictionaryTypeGroupedQuantityKeyTypeValue.lower(lists), $0
        )
    })
}

public func parseAisleConfig(input: String) -> AisleConf {
    return try! FfiConverterTypeAisleConf.lift(try! rustCall {
        uniffi_cooklang_bindings_fn_func_parse_aisle_config(
            FfiConverterString.lower(input), $0
        )
    })
}

public func parseMetadata(input: String) -> [String: String] {
    return try! FfiConverterDictionaryStringString.lift(try! rustCall {
        uniffi_cooklang_bindings_fn_func_parse_metadata(
            FfiConverterString.lower(input), $0
        )
    })
}

public func parseRecipe(input: String) -> CooklangRecipe {
    return try! FfiConverterTypeCooklangRecipe.lift(try! rustCall {
        uniffi_cooklang_bindings_fn_func_parse_recipe(
            FfiConverterString.lower(input), $0
        )
    })
}

private enum InitializationResult {
    case ok
    case contractVersionMismatch
    case apiChecksumMismatch
}

// Use a global variable to perform the versioning checks. Swift ensures that
// the code inside is only computed once.
private var initializationResult: InitializationResult = {
    // Get the bindings contract version from our ComponentInterface
    let bindings_contract_version = 26
    // Get the scaffolding contract version by calling the into the dylib
    let scaffolding_contract_version = ffi_cooklang_bindings_uniffi_contract_version()
    if bindings_contract_version != scaffolding_contract_version {
        return InitializationResult.contractVersionMismatch
    }
    if uniffi_cooklang_bindings_checksum_func_combine_ingredient_lists() != 48727 {
        return InitializationResult.apiChecksumMismatch
    }
    if uniffi_cooklang_bindings_checksum_func_parse_aisle_config() != 49190 {
        return InitializationResult.apiChecksumMismatch
    }
    if uniffi_cooklang_bindings_checksum_func_parse_metadata() != 1124 {
        return InitializationResult.apiChecksumMismatch
    }
    if uniffi_cooklang_bindings_checksum_func_parse_recipe() != 10849 {
        return InitializationResult.apiChecksumMismatch
    }
    if uniffi_cooklang_bindings_checksum_method_aisleconf_category_for() != 17275 {
        return InitializationResult.apiChecksumMismatch
    }

    return InitializationResult.ok
}()

private func uniffiEnsureInitialized() {
    switch initializationResult {
    case .ok:
        break
    case .contractVersionMismatch:
        fatalError("UniFFI contract version mismatch: try cleaning and rebuilding your project")
    case .apiChecksumMismatch:
        fatalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    }
}

// swiftlint:enable all
